<?php
/**
 * Voice Over Studio functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package Voice Over Studio
 */

if ( ! defined( 'VOICE_OVER_STUDIO_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'VOICE_OVER_STUDIO_VERSION', wp_get_theme()->get( 'Version' ) );
}

if ( ! function_exists( 'voice_over_studio_setup' ) ) :
	/**
	 * Sets up theme defaults and registers support for various WordPress features.
	 *
	 * Note that this function is hooked into the after_setup_theme hook, which
	 * runs before the init hook. The init hook is too late for some features, such
	 * as indicating support for post thumbnails.
	 */
	function voice_over_studio_setup() {

		load_theme_textdomain( 'voice-over-studio', get_template_directory() . '/languages' );

		// Add default posts and comments RSS feed links to head.
		add_theme_support( 'automatic-feed-links' );

		add_theme_support( 'align-wide' );

		add_theme_support( 'woocommerce' );

		// Add support for block styles.
		add_theme_support( 'wp-block-styles' );

		// Enqueue editor styles.
		add_editor_style( 'style.css' );

		// Add support for core custom logo.
		add_theme_support(
			'custom-logo',
			array(
				'height'      => 192,
				'width'       => 192,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		// Enqueue editor styles.
		// add_editor_style( 'style.css' );

		// Experimental support for adding blocks inside nav menus
		add_theme_support( 'block-nav-menus' );

		// Add support for experimental link color control.
		add_theme_support( 'experimental-link-color' );
	}
endif;
add_action( 'after_setup_theme', 'voice_over_studio_setup' );

/**
 * Enqueue scripts and styles.
 */
function voice_over_studio_scripts() {
	wp_enqueue_style('voice-over-studio-style', get_stylesheet_uri(), array() );
	wp_enqueue_script( 'jquery-wow', esc_url(get_template_directory_uri()) . '/js/wow.js', array('jquery') );
	wp_enqueue_style( 'animate-css', esc_url(get_template_directory_uri()).'/css/animate.css' );
	wp_enqueue_style( 'owl.carousel-style', get_template_directory_uri().'/css/owl.carousel.css' );
	wp_enqueue_script( 'owl.carousel-js', get_template_directory_uri(). '/js/owl.carousel.js', array('jquery') ,'',true);
	wp_enqueue_script( 'voice-over-studio-custom-scripts', get_template_directory_uri() . '/js/custom.js', array('jquery'),'' ,true );
	wp_style_add_data( 'voice-over-studio-style', 'rtl', 'replace' );
}
add_action( 'wp_enqueue_scripts', 'voice_over_studio_scripts' );

/**
 * Enqueue block editor style
 */
function voice_over_studio_block_editor_styles() {
	wp_enqueue_style( 'voice-over-studio-block-patterns-style-editor', get_theme_file_uri( '/css/block-editor.css' ), false, '1.0', 'all' );	
}
add_action( 'enqueue_block_editor_assets', 'voice_over_studio_block_editor_styles' );

function voice_over_studio_init_setup() {
	define('VOICE_OVER_STUDIO_BUY_NOW',__('https://www.vwthemes.com/products/voice-over-wordpress-theme','voice-over-studio'));
	define('VOICE_OVER_STUDIO_SUPPORT',__('https://wordpress.org/support/theme/voice-over-studio/','voice-over-studio'));
	define('VOICE_OVER_STUDIO_REVIEW',__('https://wordpress.org/support/theme/voice-over-studio/reviews/','voice-over-studio'));
	define('VOICE_OVER_STUDIO_LIVE_DEMO',__('https://www.vwthemes.net/voice-over-studio-pro/','voice-over-studio'));
	define('VOICE_OVER_STUDIO_PRO_DOC',__('https://preview.vwthemesdemo.com/docs/voice-over-studio-pro/','voice-over-studio'));
	define('VOICE_OVER_STUDIO_FREE_DOC',__('https://preview.vwthemesdemo.com/docs/free-voice-over-studio/','voice-over-studio'));
	define('VOICE_OVER_STUDIO_THEME_BUNDLE_BUY_NOW',__('https://www.vwthemes.com/products/wp-theme-bundle','voice-over-studio'));
	define('VOICE_OVER_STUDIO_THEME_BUNDLE_DOC',__('https://preview.vwthemesdemo.com/docs/theme-bundle/','voice-over-studio'));

	// Add block patterns
	require get_template_directory() . '/inc/block-patterns.php';

	/**
	 * Section Pro
	 */
	require get_template_directory() . '/inc/section-pro/customizer.php';

	/**
	 * TGM
	 */
	require_once get_template_directory() . '/inc/tgm/plugin-activation.php';

	/**
	 * notice
	 */
	require get_template_directory() . '/inc/core/activation-notice.php';

	/**
	 * Load core file.
	 */
	require_once get_template_directory() . '/inc/core/theme-info.php';

	require_once get_template_directory() . '/inc/core/template-functions.php';
}
add_action( 'after_setup_theme', 'voice_over_studio_init_setup' );	

/* Enqueue admin-notice-script js */
add_action('admin_enqueue_scripts', function ($hook) {
    //if ($hook !== 'appearance_page_voice-over-studio') return;

    wp_enqueue_script('admin-notice-script', get_template_directory_uri() . '/inc/core/js/admin-notice-script.js', ['jquery'], null, true);
    wp_localize_script('admin-notice-script', 'pluginInstallerData', [
        'ajaxurl'     => admin_url('admin-ajax.php'),
        'nonce'       => wp_create_nonce('install_plugin_nonce'), // Match this with PHP nonce check
        'redirectUrl' => admin_url('admin.php?page=voice-over-studio-info'),
    ]);
});

add_action('wp_ajax_check_plugin_activation', function () {
    if (!isset($_POST['plugin']) || empty($_POST['plugin'])) {
        wp_send_json_error(['message' => 'Missing plugin identifier']);
    }

    include_once ABSPATH . 'wp-admin/includes/plugin.php';

    // Map plugin identifiers to their main files
    $voice_over_studio_plugin_map = [
    	'mp3-music-player-by-sonaar'          => 'mp3-music-player-by-sonaar/sonaar-music.php',
        'ibtana'               => 'ibtana-visual-editor/plugin.php',
    ];

    $voice_over_studio_requested_plugin = sanitize_text_field($_POST['plugin']);

    if (!isset($voice_over_studio_plugin_map[$voice_over_studio_requested_plugin])) {
        wp_send_json_error(['message' => 'Invalid plugin']);
    }
});

function voice_over_studio_dismissed_notice() {
	update_option( 'voice_over_studio_admin_notice', true );
}
add_action( 'wp_ajax_voice_over_studio_dismissed_notice', 'voice_over_studio_dismissed_notice' );

add_action('admin_init', function() {
    // If KK Star Ratings tries to open → redirect to Get Started
    if (isset($_GET['page']) && $_GET['page'] === 'mp3-player-setup-wizard') {
        // Remove Freemius redirect flags
        delete_option('srmp3_free_wizard_redirect');
	    wp_redirect(admin_url('themes.php?page=voice-over-studio-info'));
        exit;
	}
},0);
